/***************************************************************************/
/*  UPSSV-WPS-Object-Creation.cmd                                          */
/*                                                                         */
/*  Copyright 2008 Uwe Jacobs, Rainer D. Stroebel                          */ 
/*                                                                         */
/*                                                                         */
/*  Function:                                                              */
/*  Create WPS Folder and Program Objects for UPSSV Package                */
/*                                                                         */
/*                                                                         */
/*  Agruments passed from caller:                                          */
/*  UPSSV-Installer-This-cmd-requires-your-Modification.cmd                */
/*                                                                         */
/*  ARG variable                  value ( for example )                    */
/*  -------------------------------------------------------------------    */
/*  0  IN_UPSSV_Inst_Path         S:\UPSSV-v-1-0                           */
/*  1  IN_MOZILLA_DRIVE           S:                                       */
/*  2  IN_MOZILLA_DIR             MoF-3000                                 */
/*  3  IN_User_Profile_Prod_Path  S:\mof-3000\mozilla\Firefox\Profiles\xxxx.default */
/*  4  IN_User_Profile_Save_Drive P:                                       */
/*  5  IN_User_Profile_Save_Dir   MoF-3000-Save                            */
/*                                                                         */
/* History:                                                                */
/* 0.1  2008-07-12 23.00 Intial creation of sample by code by Uwe          */
/* 0.2  2008-07-13 09.30 sampel code adapted by Rainer                     */
/* 0.3  2008-07-13 16.00 code debuged by Uwe                               */
/* 0.4  2008-07-13 18.00 add code for parse source and test against arg    */
/* 0.5  2008-07-13 20.00 add STARTUPDIR to Program Objects                 */
/* 0.6  2008-07-13 23.00 add New_Line Zeilenumbruch im Titel String        */
/* 0.7  2008-07-14 17.00 add Error handling - display more Information     */
/* 0.8  2008-07-16       add Obj  for Vacuum-Impact-History-File.txt       */
/* 0.9  2008-07-16 15.35 parse source --> parse upper source               */
/*                       Feedback Christian H.                             */
/*                                                                         */
/***************************************************************************/

  Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs';
  Call SysLoadFuncs;

  Return_Code = 0 

  parse upper source . . IN_theFilePath
  
  IN_theDir=FILESPEC('drive', IN_theFilePath)||FILESPEC('path', IN_theFilePath)


  say "IN_source" IN_theDIR 
  say arg(1)

  PARSE UPPER ARG IN_UPSSV_Inst_Path,
                  IN_MOZILLA_DRIVE,
                  IN_MOZILLA_DIR,
                  IN_User_Profile_Prod_Path,
                  IN_User_Profile_Save_Drive,
                  IN_User_Profile_Save_Dir;

 IF IN_UPSSV_Inst_Path || "\"  \=  IN_theDir then,
        DO
        SAY "UPSSV 001E Error UPSSV_Inst_Path =" """" ||IN_UPSSV_Inst_Path || """" 
        say "is not qual to the source dir of this Rexx Procedure"
        say """" || IN_TheDir || """"  
        say IN_theFilePath "- I am abborting!"
        Return_Code = 2
        Return (Return_Code)
        END 
 
                                          /* Ordner anlegen */
 New_Line="0A"X

 UPSSV_Folder_Titel = "UPSSV 1.0"    || New_Line  , 
                                     || "User Profile Save and SQLite Vacuum" || New_Line,
                                     || "for Firefox 3.0";  

                                          /* WPS Program Objects definieren,
                                             bitte berflssige Daten entfernen.
                                             jedoch BITTE als letzten Eintrag
                                             ein leeres Item anbieten 
                                           */ 

 WPS_Prog_Titel.1 =  "UPSSV"         || New_Line  ,
                                     || "Save and Vacuum" 			 

 WPS_Prog_PGM.1   =  "EXENAME="      || IN_UPSSV_Inst_Path || "\",
                                     || "UPSSV-Main-User-Profile-Save-and-SQLite-Vacuum.cmd",
                                     ||  ";" , 
                  || "PARAMETERS="   || IN_MOZILLA_DRIVE,
                                        IN_MOZILLA_DIR,
                                        IN_User_Profile_Prod_Path,
                                        IN_User_Profile_Save_Drive, 
                                        IN_User_Profile_Save_Dir,
                                     || ";",
                  || "STARTUPDIR="   || IN_UPSSV_Inst_Path ,
                                     ||  ";"                                            

 WPS_Prog_Titel.2 =  "UPSSV"         || New_Line  ,
                                     || "Execution Log last";

 WPS_Prog_PGM.2   =  "EXENAME="      || "e.exe", 
                                     ||  ";" , 
                  || "PARAMETERS="   || IN_MOZILLA_DRIVE   || "\",
                                     || IN_MOZILLA_DIR     || "\", 
                                     || IN_MOZILLA_DIR     || "-Vacuum-Log-Gen-minus-0",
                                     || ";"


 WPS_Prog_Titel.3 =  "UPSSV"         || New_Line  ,
                                     || "Vacuum Impact History";

 WPS_Prog_PGM.3   =  "EXENAME="      || "e.exe", 
                                     ||  ";" , 
                  || "PARAMETERS="   || IN_MOZILLA_DRIVE   || "\",
                                     || IN_MOZILLA_DIR     || "\", 
                                     || IN_MOZILLA_DIR     || "-Vacuum-Impact-History-File.txt",
                                     || ";"


 WPS_Prog_Titel.4 =  "UPSSV Support" || New_Line ,  
                                     || "Execution Log temporary"  || New_Line ,
                                     || "to check after abend"

 WPS_Prog_PGM.4   =  "EXENAME="      || "e.exe", 
                                     ||  ";" , 
                  || "PARAMETERS="   || IN_MOZILLA_DRIVE   || "\",
                                     || IN_MOZILLA_DIR     || "\", 
                                     || IN_MOZILLA_DIR     || "-Vacuum-Log-TMP-Run",
                                     || ";" 

                  
 WPS_Prog_Titel.5 =  "UPSSV Support" ||  New_Line , 
                                     || "Lock File Delete";          
			 
 WPS_Prog_PGM.5   =  "EXENAME="      || IN_UPSSV_Inst_Path  || "\",
                                     || "UPSSV-Lock-File-Delete.cmd",
                                     ||  ";" , 
                  || "PARAMETERS="   || IN_MOZILLA_DRIVE,
                                        IN_MOZILLA_DIR ,          
                                     || ";", 
                  || "STARTUPDIR="   || IN_MOZILLA_DRIVE    || "\",
                                     || IN_MOZILLA_DIR ,
                                     ||  ";"

                                          
 WPS_Prog_Titel.6 =  "UPSSV Mod"     ||  New_Line ,
                                     ||  "Firefox Start via Template" ||  New_Line ,
                                     ||  "Customization requried"

 WPS_Prog_PGM.6   =  "EXENAME="      || "e.exe", 
                                     ||  ";" , 
                  || "PARAMETERS="   || IN_UPSSV_Inst_Path  || "\",
                                     || "UPSSV-Firefox-3-0-Start-with-Lock-File-Handling-Template.cmd", 
                                     || ";" 

              
 WPS_Prog_Titel.7 =  "UPSSV Mod"     ||  New_Line ,
                                     ||  "Firefox Start via Template" 
 
 WPS_Prog_PGM.7   =  "EXENAME="      || IN_UPSSV_Inst_Path  || "\",
                                     || "UPSSV-Firefox-3-0-Start-with-Lock-File-Handling-Template.cmd",
                                     ||  ";" , 
                  || "STARTUPDIR="   || IN_MOZILLA_DRIVE    || "\",
                                     || IN_MOZILLA_DIR ,
                                     ||  ";"

 WPS_Prog_Titel.8 = ""
 WPS_Prog_PGM.8   = ""

                                                           /* Folder anlegen  */

 WPS_Shadow_Daten.1 = IN_UPSSV_Inst_Path  || "\README.TXT"  
 WPS_Shadow_Daten.2 = ""

 Return_Code = 0 

  FolderRef = "OBJECTID=<UPSSVFolder>";   

  if SysCreateObject("WPFolder",UPSSV_Folder_Titel,"<WP_DESKTOP>",FolderRef,"R") Then 
  DO
                                                           /* Programme anlegen */ 
    DO i = 1 to 10
      if WPS_Prog_PGM.i    = "" then LEAVE 
      rc=SysCreateObject("WPProgram",WPS_Prog_Titel.i,"<UPSSVFolder>",WPS_Prog_PGM.I,"R");
      if rc = 0 then do
                     Say "UPSSV 002S Error SysCreateObject " WPS_Prog_Titel.i WPS_Prog_PGM.I
                     Return_Code = 3
                     Return (Return_Code)
                     end;
      End;
    Do i = 1 to 10
      if WPS_Shadow_Daten.i = "" then LEAVE  
      rc = syscreateshadow(WPS_Shadow_Daten.i,"<UPSSVFolder>")
      if rc = 0 then do
                     Say "UPSSV 003S Error SysCreateShadow" WPS_Shadow_Daten.i 
                     Return_Code = 3
                     Return (Return_Code)
                     end;
      End; 
  end;      
   else
    DO
    SAY "UPSSV 004S Fehler bei Create Folder rc=" rc
    Return_Code = 3
    Return (Return_Code) 
    end;

Return (Return_Code)  /* end of main procedure */ 

/************************************************************************************/
/* Overview of the Information / Warning / Errors / Sever Error Messages of program */ 
/************************************************************************************/
/*
    "UPSSV 001E Error UPSSV_Inst_Path =" """" ||IN_UPSSV_Inst_Path || """" 
                "is not qual to the source dir of this Rexx Procedure"
                """" || IN_TheDir || """"  
                IN_theFilePath "- I am abborting!"

    "UPSSV 002S Error SysCreateObject " WPS_Prog_Titel.i WPS_Prog_PGM.I

    "UPSSV 003S Error SysCreateShadow" WPS_Shadow_Daten.i 

    "UPSSV 004S Fehler bei Create Folder rc=" rc
*/
/************************************************************************************/
/* End of Code                                                                      */ 
/************************************************************************************/